﻿Imports Microsoft.DirectX.DirectSound
Imports System.IO

Namespace Roton
    Public Class AudioDirectX9
        Implements Audio

        Private Structure RIFFEntry
            Public Tag As Int32
            Public Data() As Byte
        End Structure

        Private Structure Sample
            Public Data() As Byte
            Public Freq As Integer

            Public Sub New(ByVal NewData() As Byte, ByVal NewFreq As Integer)
                Data = NewData
                Freq = NewFreq
            End Sub
        End Structure

        Private Class Instrument
            Public Samples As New List(Of Sample)
            Public Map() As Integer

            Public Sub New()
                ReDim Map(95)
            End Sub

            Public Sub New(ByVal NewSample As Sample)
                MyBase.New()
                Samples.Add(NewSample)
            End Sub

            Public Sub New(ByVal NewSampleList() As Sample, ByVal NewMap() As Integer)
                Samples.AddRange(NewSampleList)
                Map = NewMap
            End Sub
        End Class

        Private Dev As Device

        Public Sub New(ByVal OwnerForm As Form)
            Dev = New Device
            Dev.SetCooperativeLevel(OwnerForm, CooperativeLevel.Normal)
        End Sub

        Protected Overrides Sub Finalize()
            MyBase.Finalize()
            Dev.Dispose()
            Dev = Nothing
        End Sub
    End Class
End Namespace